Package: interleave
Type: Package
Title: Converts Tabular Data to Interleaved Vectors
Version: 0.1.2
Date: 2024-01-18
Authors@R: c(
        person("David", "Cooley", email = "david.cooley.au@gmail.com", role = c("aut", "cre")), 
        person("Mapbox", role = "cph", comment = "author of header library earcut.hpp")
        )
Description: Converts matrices and lists of matrices into a single vector by interleaving 
    their values. That is, each element of the result vector is filled from the input 
    matrices one row at a time. This is the same as transposing a matrix, then removing the 
    dimension attribute, but is designed to operate on matrices in nested list structures.
License: MIT + file LICENSE
Encoding: UTF-8
RoxygenNote: 7.2.3
Depends: R (>= 3.0.2)
LinkingTo: geometries (>= 0.2.4), Rcpp
Imports: Rcpp
Suggests: covr, sfheaders, tinytest
NeedsCompilation: yes
Packaged: 2024-01-17 23:38:07 UTC; dave
Author: David Cooley [aut, cre],
  Mapbox [cph] (author of header library earcut.hpp)
Maintainer: David Cooley <david.cooley.au@gmail.com>
Repository: CRAN
Date/Publication: 2024-01-17 23:50:02 UTC
Built: R 4.6.0; x86_64-apple-darwin20; 2026-04-26 20:19:45 UTC; unix
Archs: interleave.so.dSYM

[![R build
status](https://github.com/dcooley/interleave/workflows/R-CMD-check/badge.svg)](https://github.com/dcooley/interleave/actions)
[![Codecov test
coverage](https://codecov.io/gh/dcooley/interleave/branch/master/graph/badge.svg)](https://app.codecov.io/gh/dcooley/interleave?branch=master)

<img src="./man/figures/interleaving.gif" width="256px" height="256px" />

# interleave

As the amazing gif shows, **interleaving** in this context means
converting a matrix into a vector, filled in a row-wise manner.

I’m building this library to be the workhorse for converting matrices
(and lists of matrices) into single, interleaved vectors, ready for
WebGL applications.

Here are some simple examples

``` r

( mat1 <- matrix(1:20, ncol = 2, byrow = T) )
#       [,1] [,2]
#  [1,]    1    2
#  [2,]    3    4
#  [3,]    5    6
#  [4,]    7    8
#  [5,]    9   10
#  [6,]   11   12
#  [7,]   13   14
#  [8,]   15   16
#  [9,]   17   18
# [10,]   19   20

interleave( mat1 )
#  [1]  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20

( mat2 <- matrix(20:1, ncol = 5, byrow = T) )
#      [,1] [,2] [,3] [,4] [,5]
# [1,]   20   19   18   17   16
# [2,]   15   14   13   12   11
# [3,]   10    9    8    7    6
# [4,]    5    4    3    2    1

interleave( mat2 )
#  [1] 20 19 18 17 16 15 14 13 12 11 10  9  8  7  6  5  4  3  2  1

lst <- list( mat1, mat2 )

interleave( lst )
#  [1]  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 20 19 18 17 16
# [26] 15 14 13 12 11 10  9  8  7  6  5  4  3  2  1
```

## For points, each row of each matrix inside each list is its own POINT

v <- 1:2
expect_error( interleave:::rcpp_interleave_point(v), "interleave - expecting a list")

## matrix (LINESTRING)
m <- matrix(1:4, ncol = 2, byrow = T)
expect_error( interleave:::rcpp_interleave_point(m), "interleave - expecting a list")

m <- matrix(1:4, ncol = 2, byrow = T)
l <- list( m )
res <- interleave:::rcpp_interleave_point(l)
expect_equal( res$coordinates, 1:4 )
expect_equal( res$start_indices, c(0:1) )
expect_equal( res$stride, 2 )

## 2 matrices in a list (MULTILINESTRING / POLYGON )
m1 <- matrix(1:4, ncol = 2, byrow = T)
m2 <- matrix(5:8, ncol = 2, byrow = T)
l <- list( m1, m2 )
res <- interleave:::rcpp_interleave_point(l)
expect_equal( res$coordinates, 1:8 )
expect_equal( res$start_indices, c(0:3) )
expect_equal( res$stride, 2 )

## list of list of two matrices
l2 <- list( l )
res <- interleave:::rcpp_interleave_point(l)
expect_equal( res$coordinates, 1:8 )
expect_equal( res$start_indices, c(0:3) )
expect_equal( res$stride, 2 )

expect_equal(
  interleave:::rcpp_interleave_point( l )$coordinates
  , interleave:::rcpp_interleave_point( l2 )$coordinates
)

expect_equal(
  interleave:::rcpp_interleave_point( l )$start_indices
  , interleave:::rcpp_interleave_point( l2 )$start_indices
)

expect_equal(
  interleave:::rcpp_interleave_point( l )$total_coordinates
  , interleave:::rcpp_interleave_point( l2 )$total_coordinates
)

expect_equal(
  interleave:::rcpp_interleave_point( l )$stride
  , interleave:::rcpp_interleave_point( l2 )$stride
)

## Geometry coordiantes are the coordinates of the original geometries
## so they should be different
expect_false(
  all(
    interleave:::rcpp_interleave_point( l )$geometry_coordinates ==
      interleave:::rcpp_interleave_point( l2 )$geometry_coordinates
  )
)

## Matrices with un-equal strides
m1 <- matrix(1:4, ncol = 2, byrow = T)
m2 <- matrix(1:6, ncol = 3, byrow = T)
l <- list( m1, m2 )
res <- interleave:::rcpp_interleave_point(l)

v <- 1:4
expect_error( interleave:::rcpp_interleave_line( v ), "interleave - expecting a list")


m <- matrix(1:4, ncol = 2)
expect_error( interleave:::rcpp_interleave_line( m ), "interleave - expecting a list")

expect_error( interleave:::rcpp_interleave_line( list() ), "interleave - empty list")

## interleave_line() should only accept LIST inputs
## matrix (e.g. LINESTRING)
m <- matrix(1:16, ncol = 2, byrow = T)
l <- list( m )
res <- interleave:::rcpp_interleave_line( l )
expect_equal( res$coordinates, 1:16 )
expect_equal( res$start_indices, 0 ) ## Only one line
expect_equal( res$stride, 2 )
expect_equal( sum( res$total_coordinates ), sum(sapply(l, nrow)) )
expect_equal( res$geometry_coordinates, sapply(l, nrow) )

## Two linestrings (or a polygon)
l <- list( m, m )
res <- interleave:::rcpp_interleave_line( l )
expect_equal( res$coordinates, c(1:16, 1:16) )
expect_equal( res$start_indices, c(0,8) ) ## two lines
expect_equal( res$stride, 2 )
expect_equal( sum( res$total_coordinates ), sum(sapply(l, nrow)) )
expect_equal( res$geometry_coordinates, sapply(l, nrow) )

## A mixture of a line and a polygon
m1 <- matrix(1:4, ncol = 2, byrow = T)
m2 <- matrix(c(0,0,0,1,1,1,1,0,0,0), ncol = 2, byrow = T)
l <- list( m1, m2 )
res <- interleave:::rcpp_interleave_line( l )
expect_equal( res$coordinates, c(1:4, 0,0,0,1,1,1,1,0,0,0))
expect_equal( res$start_indices, c(0, 2) )
expect_equal( sum( res$total_coordinates ), sum(sapply(l, nrow)) )
expect_equal( res$geometry_coordinates, sapply(l, nrow) )


### Every possible type of sfg, sfc or any nested set of matrices (or not nested)
### need to be interleaved

m1 <- matrix(1:6, ncol = 2, byrow = T)
m2 <- matrix(7:12, ncol = 2, byrow = T)
m3 <- matrix(13:18, ncol = 2, byrow = T)

l <- list(
  1:2 ## POINT
  , m1 ## LINESTRING
  , list( m1, m2 ) ## POLYGON / MULTILINESTRING
  , list( list( m1 ), list( m2, m3 ) ) ## MULTIPOLYGON
)

res <- interleave:::rcpp_interleave_line( l )

coords <- c(
  1:2
  , as.vector( t(m1) )
  , as.vector( t(m1) )
  , as.vector( t(m2) )
  , as.vector( t(m1) )
  , as.vector( t(m2) )
  , as.vector( t(m3) )
)

expect_equal( res$coordinates, coords )

## start_indices should be one for each matrix
expect_true( length( res$start_indices ) == 7)
expect_equal( res$start_indices, c(0, 1, 4, 7, 10, 13, 16 ))
expect_true( res$total_coordinates == 19 )
expect_equal( res$geometry_coordinates, c(1,3,6,9) )


## Test all SF types return the same result
df <- data.frame(
  id1 = rep(1,10)
  , id2 = c( rep(1, 5), rep(2, 5) )
  , x = 1:10
  , y = 10:1
)

sf_pt <- sfheaders::sf_point(
  obj = df
  , x = "x"
  , y = "y"
)

sf_line <- sfheaders::sf_linestring(
  obj = df
  , x = "x"
  , y = "y"
  , linestring_id = "id1"
)

sf_polygon <- sfheaders::sf_polygon(
  obj = df
  , x = "x"
  , y = "y"
  , polygon_id = "id1"
  , close = FALSE
)

res_pt <- interleave:::rcpp_interleave_line( sf_pt$geometry )
res_ln <- interleave:::rcpp_interleave_line( sf_line$geometry )
res_poly <- interleave:::rcpp_interleave_line( sf_polygon$geometry )

expect_equal( res_pt$coordinates, res_ln$coordinates )
expect_equal( res_ln$coordinates, res_poly$coordinates )


###
# A list containing
# \itemize{
#   \item{dimensions - a 5-column matrix where \itemize{
#     \item{column 1 - the start-index of the geometry}
#     \item{column 2 - the end-index of the geometry}
#     \item{column 3 - the dimension of the geometry}
#     \item{column 4 - the nesting level of the geometry}
#     \item{column 5 - the SEXP type of the geometry}
#     }
#   }
#   \item{max_dimension - the maximum dimension in all the geometries}
#   \item{max_nest - the maximum nesting level in all the geometries}
# }
## Test the dimeions are correctly cacluated

## sfg POINT (vector) (1 'line')
v <- 1L:4L
dim <- geometries:::rcpp_geometry_dimensions( v )
expect_true( nrow( dim$dimensions ) == 1 )
expect_true( dim$max_dimension == 4 )
expect_true( dim$max_nest == 0 )


### sfc POINTs (2 'lines')
l <- list(1:4, 1:3)
dim <- geometries:::rcpp_geometry_dimensions( l )
expect_true( nrow( dim$dimensions ) == 2 )
expect_true( dim$max_dimension == 4 )
expect_true( dim$max_nest == 1 )

### sfg LINESTRING (matrix)
m <- matrix(1:6, ncol = 2)
dim <- geometries:::rcpp_geometry_dimensions( m )
expect_true( nrow( dim$dimensions ) == 1 )
expect_true( dim$max_dimension == 2 )
expect_true( dim$max_nest == 0 )

### sfg MULTILINESTRING
### sfg POLYGON
### sfc LINESTRINGs
l <- list( m )
dim <- geometries:::rcpp_geometry_dimensions( l )
expect_true( nrow( dim$dimensions ) == 1 )
expect_true( dim$max_dimension == 2 )
expect_true( dim$max_nest == 1 )

l <- list( m, m )
dim <- geometries:::rcpp_geometry_dimensions( l )
expect_true( nrow( dim$dimensions ) == 2 )
expect_true( dim$max_dimension == 2 )
expect_true( dim$max_nest == 1 )

### sfg MULTIPOLYGON
### sfc POLYGON
l <- list( list( m ) )
dim <- geometries:::rcpp_geometry_dimensions( l )
expect_true( nrow( dim$dimensions ) == 1 )
expect_true( dim$max_dimension == 2 )
expect_true( dim$max_nest == 2 )

## interleave()

## matrix (e.g. a LINESTRING)
m1 <- matrix(1:20, ncol = 2, byrow = TRUE )
res <- interleave( m1 )
expect_equal(1:20, res)


## list of matrices (e.g. a POLYIGON)
m2 <- matrix(20:1, ncol = 2, byrow = TRUE )
l <- list( m1, m2 )
res <- interleave( l )
expect_equal(c(1:20,20:1) , res )

## nested list of matrices
l <- list( m1, list( list( m2 ) ) )
res <- interleave( l )
expect_equal(c(1:20,20:1) , res )

## Only numeric values can be interleaved
err <- "interleave - can not interleave this type of object"
expect_error( interleave:::.test_interleave( T ), err )
expect_error( interleave:::.test_interleave( raw() ), err )
expect_error( interleave:::.test_interleave( complex() ), err )

expect_equal( interleave:::.test_interleave( 1:4 ), 1:4 )
expect_equal( interleave:::.test_interleave( list(1:4) ), 1:4 )

## Test that data.frames are not supported
df <- data.frame(
  x = 1:5
  , y = 5:1
)
expect_error( interleave( df ), "interleave - data.frames are currently not supported")

expect_error( interleave:::.test_interleave_primitive( list(), 1 ), "interleave - empty list" )
expect_error( interleave:::.test_interleave_primitive( 1:4, 2), "interleave - expecting a list" )

expect_error( interleave:::.test_interleave_primitive( list(1:4), 3 ), "interleave - unknown primitive type" )


expect_error( interleave:::.test_subset_vector( 1:4, -1 ), "index error" )
expect_error( interleave:::.test_subset_vector( 1:4, 4 ), "index error" )

expect_equal( interleave:::.test_subset_vector( 1:4, 2 ), 3 )
expect_equal( interleave:::.test_subset_vector( c(T,T,F), 0 ), 1 ) ## logial is coerced to integer
expect_equal( interleave:::.test_subset_vector( c(T,T,F), 2 ), 0 ) ## logial is coerced to integer

expect_equal( interleave:::.test_subset_vector( c(1.2, 1.3, 1.4), 0 ), 1.2 )
expect_error( interleave:::.test_subset_vector( complex(1), 0 ), "interleave - unknown vector type")

## Test that interleaving triangles only accept list( list(matrix) ) inputs
m <- matrix(c(0,0,0,1,1,1,1,0,0,0), ncol = 2, byrow = T)
expect_error( interleave:::rcpp_interleave_triangle( m, list() ), "interleave - expecting a list" )

## single polygon
## This won't work for triangulating because it needs a collection,
## not a single (sfg) geometry.
## for a single geometry you would use earcut()
m <- matrix(c(0,0,0,1,1,1,1,0,0,0), ncol = 2, byrow = T)
l <- list( m )
expect_silent( interleave:::rcpp_earcut( l ) )
expect_error( interleave:::rcpp_interleave_triangle( l, list() ), "interleave - a list must only contain matrices")


## single multipolygon is treated as two POLYGONs
m1 <- matrix(c(0,0,0,1,1,1,1,0,0,0), ncol = 2, byrow = T)
h <- matrix(c(0.25,0.25,0.25,0.75,0.75,0.75,0.75,0.25,0.25,0.25), ncol = 2, byrow = T)
m2 <- matrix(c(2,2,2,3,3,3,3,2,2,2), ncol = 2, byrow = T)
l <- list( list( m1, h ), list( m2 ) )
expect_silent( interleave:::rcpp_interleave_triangle( l, list() ) )
## but it won't work for earcutting
expect_error( interleave:::rcpp_earcut( l ), "interleave - a list must only contain matrices" )

## testing what 'geometries::dimensions' give
## single polygon
m <- matrix(c(0,0,0,1,1,1,1,0,0,0), ncol = 2, byrow = T)
l <- list( m )
dim <- geometries:::rcpp_geometry_dimensions( l )
expect_true( nrow( dim$dimensions ) == 1 )


## Two polygons
m1 <- matrix(c(0,0,0,1,1,1,1,0,0,0), ncol = 2, byrow = T)
m2 <- matrix(c(0.25,0.25,0.25,0.75,0.75,0.75,0.75,0.25,0.25,0.25), ncol = 2, byrow = T)
l <- list( list( m1 ), list( m2 ) )
dim <- geometries:::rcpp_geometry_dimensions( l )
expect_true( nrow( dim$dimensions ) == 2 )

## polygon with hole
m <- matrix(c(0,0,0,1,1,1,1,0,0,0), ncol = 2, byrow = T)
h <- matrix(c(0.25,0.25,0.25,0.75,0.75,0.75,0.75,0.25,0.25,0.25), ncol = 2, byrow = T)
l <- list( m, h )
dim <- geometries:::rcpp_geometry_dimensions( l )
expect_true( nrow( dim$dimensions ) == 2 )

## Two polygons, one with a hole
m1 <- matrix(c(0,0,0,1,1,1,1,0,0,0), ncol = 2, byrow = T)
h <- matrix(c(0.25,0.25,0.25,0.75,0.75,0.75,0.75,0.25,0.25,0.25), ncol = 2, byrow = T)
m2 <- matrix(c(2,2,2,3,3,3,3,2,2,2), ncol = 2, byrow = T)
l <- list( list( m, h ), list( m2 ) )
dim <- geometries:::rcpp_geometry_dimensions( l )
expect_true( nrow( dim$dimensions ) == 2 ) ## because there are two separate objects


## polygon with hole
## - single 'sfg' type should error
m <- matrix(c(0,0,0,1,1,1,1,0,0,0), ncol = 2, byrow = T)
h <- matrix(c(0.25,0.25,0.25,0.75,0.75,0.75,0.75,0.25,0.25,0.25), ncol = 2, byrow = T)
l <- list( m, h )
expect_error( interleave:::rcpp_interleave_triangle( l, list() ), "interleave - a list must only contain matrices" )
## TODO: ^^ possibly change this error by checking for the internal object type inside each
## list element of the obj (in rcpp_interleave_trinagle)
##
## Nest it inside an 'sfc'
l <- list( list( m, h )  )
res <- interleave:::rcpp_interleave_triangle( l, list() )
ec <- interleave:::rcpp_earcut( l[[1]] )
expect_equal( res$coordinates, ec$coordinates )


## Testing Z(M) coordinates remain on the correct triangle
m <- matrix(c(0,0,1,0,1,2,1,1,3,1,0,4,0,0,1), ncol = 3, byrow = T)
sf <- sfheaders::sf_polygon(m)

res <- interleave:::rcpp_interleave_triangle( sf$geometry, list() )
res_mat <- matrix( res$coordinates, ncol = 3, byrow = T)

expect_equal( m[res$input_index + 1, ], res_mat )


## Testing on a non-closed matrix
m <- matrix(c(0,0,1,0,1,2,1,1,3,1,0,4), ncol = 3, byrow = T)
sf <- sfheaders::sf_polygon(m)
res1 <- interleave:::rcpp_interleave_triangle( sf$geometry, list() )

m <- matrix(c(0,0,1,0,1,2,1,1,3,1,0,4,0,0,1), ncol = 3, byrow = T)
sf <- sfheaders::sf_polygon(m)
res2 <- interleave:::rcpp_interleave_triangle( sf$geometry, list() )

expect_equal(res1, res2)

## Test the input index refers to the row of the geometry, not the separate rings (outer or hole)
m1 <- matrix(c(0,0,1,0,1,2,1,1,3,1,0,4,0,0,1), ncol = 3, byrow = T)
m2 <- matrix(c(0.5,0.5,0.5,0.5,0.75,0.5,0.75,0.75,0.5,0.75,0.5,0.5,0.5,0.5,0.5), ncol = 3, byrow = T)
mat <- rbind(m1, m2)

poly <- sfheaders::sfg_polygon(list(m1,m2))
res <- interleave:::rcpp_interleave_triangle( list(poly), list() )

res_mat <- matrix( res$coordinates, ncol = 3, byrow = T)

expect_equal( mat[ res$input_index + 1, ], res_mat )

## Testing 2-polygons have the correct input_index returned
## TODO: re-implement this test when 0.3.0 is on sfheaders
# m1 <- matrix(c(0,0,1,0,1,2,1,1,3,1,0,4,0,0,1), ncol = 3, byrow = T)
# m2 <- matrix(c(0.5,0.5,0.5,0.5,0.75,0.5,0.75,0.75,0.5,0.75,0.5,0.5,0.5,0.5,0.5), ncol = 3, byrow = T)
#
# ## This rquires sfheaders v0.3.0
# poly <- sfheaders:::rcpp_sfg_polygons( list(m1, m2), "XY", FALSE )
# res <- interleave:::rcpp_interleave_triangle( poly, list() )
#
# res_mat <- matrix( res$coordinates, ncol = 3, byrow = T )
# mat <- rbind(m1, m2)
# expect_equal( mat[ res$input_index + 1, ], res_mat )
#
#
# ## Testing 3-polygons have the correct input_index returned
# m1 <- matrix(c(0,0,1,0,1,2,1,1,3,1,0,4,0,0,1), ncol = 3, byrow = T)
# m2 <- matrix(c(0.5,0.5,0.5,0.5,0.75,0.5,0.75,0.75,0.5,0.75,0.5,0.5,0.5,0.5,0.5), ncol = 3, byrow = T)
# m3 <- matrix(c(2,2,1,2,3,1,3,3,1,3,2,1,2,2,1), ncol = 3, byrow = T)
#
# poly <- sfheaders:::rcpp_sfg_polygons( list(m1, m2, m3), "XY", FALSE )
# res <- interleave:::rcpp_interleave_triangle( poly, list() )
#
# res_mat <- matrix( res$coordinates, ncol = 3, byrow = T )
# mat <- rbind(m1, m2, m3)
# expect_equal( mat[ res$input_index + 1, ], res_mat )


## Testing properties are shuffled with indexes
m <- matrix(c(0,0,0,1,1,1,1,0,0,0), ncol = 2, byrow = T)
p1 <- letters[1:5]
p2 <- letters[5:1]
p <- list( p1, p2)
l <- list( list( m ) )

res <- interleave:::rcpp_interleave_triangle( l, p )

expect_equal( p1[ res$input_index + 1 ], res$properties[[1]]  )
expect_equal( p2[ res$input_index + 1 ], res$properties[[2]]  )

## Testing a multi-row sf object with multi-row list-property columns are correctly shuffled
m1 <- matrix(c(0,0,0,1,1,1,1,0,0,0), ncol = 2, byrow = T)
m2 <- matrix(c(0,0,0,2,2,2,2,0,0,0), ncol = 2, byrow = T)
m1 <- cbind(1, m1)
m2 <- cbind(2, m2)
ls <- rbind(m1,m2)

sf <- sfheaders::sf_polygon(
  obj = ls
  , polygon_id = 1
)

p1 <- letters[1:5]
p2 <- letters[21:25]
p <- list( p1, p2)

sf$prop <- p
sf$prop2 <- list(p2, p1)

res <- interleave:::rcpp_interleave_triangle( sf$geometry, list( sf$prop ) )

## the number of properties must match the number of coordinates
expect_true(
  ( length(res$coordinates) / res$stride ) == length( res$properties[[1]] )
)

res <- interleave:::rcpp_interleave_triangle( sf$geometry, list( sf[[ c("prop2") ]] ) )
expect_equal( c(p2, p1)[ res$input_index + 1 ], res$properties[[1]] )

## Multiple list-columns
res <- interleave:::rcpp_interleave_triangle( sf$geometry, list( sf[[ c("prop" ) ]], sf[[ c("prop2") ]] ) )

expect_equal( c(p1,p2)[ res$input_index + 1 ], res$properties[[1]] )
expect_equal( c(p2,p1)[ res$input_index + 1 ], res$properties[[2]] )


## input object is not updated by-reference
expect_equal( p[[1]], letters[1:5] )
expect_equal( p[[2]], letters[21:25] )

## multiple SFGs with properties

df <- data.frame(
  id = c(1,1,1,1,1,2,2,2,2,2)
  , x = c(0,0,1,1,0, 2,2,3,3,2)
  , y = c(0,1,1,0,0, 2,3,3,2,2)
)

p1 <- letters[1:5]
p2 <- letters[5:1]

sf <- sfheaders::sf_polygon( df, polygon_id = "id")
sf$val <- list(p1,p2)

res <- interleave:::rcpp_interleave_triangle( sf$geometry, list( sf$val ) )
## properties need to be in a list to reflect the columns of a data.frame

expect_equal(
  res$properties[[1]]
  , c(p1,p2)[ res$input_index + 1 ]
)

### Do properties need to be the same nesting as the goemtry
## i.e. list[[ proerty1, property2 ]] for a polygon with a hole

df <- data.frame(
  poly_id = c(1,1,1,1,1,1,1,1,1,1)
  , line_id = c(1,1,1,1,1,2,2,2,2,2)
  , x = c(0,0,1,1,0, 2,2,3,3,2)
  , y = c(0,1,1,0,0, 2,3,3,2,2)
)

p1 <- letters[1:5]
p2 <- letters[5:1]

sf <- sfheaders::sf_polygon( df, polygon_id = "poly_id", linestring_id = "line_id")
sf$val <- list( list(p1,p2) )

res <- interleave:::rcpp_interleave_triangle( sf$geometry, list( sf$val ) )

expect_equal(
  res$properties[[1]]
  , c(p1, p2)[ res$input_index + 1 ]
)

## Testing if the properties have different lengths
df <- data.frame(
  id = c(1,1,1,1,1, 2,2,2,2,2)
  , x = c(0,0,1,1,0, 2,2,3,3,2)
  , y = c(0,1,1,0,0, 2,3,3,2,2)
)

p1 <- letters[1:4]
p2 <- letters[4:1]

sf <- sfheaders::sf_polygon( df, polygon_id = "id")
sf$val <- list(p1,p2)

## Testing that there is a property for each coordinate
expect_error(
  interleave:::rcpp_interleave_triangle( sf$geometry, list( sf$val ) )
  , "interleave - list-column properties must have the same number of elements as each geometry they belong to"
  )


## Properties the same length as number of coordinates
p1 <- letters[1:5]
p2 <- letters[5:1]

sf <- sfheaders::sf_polygon( df, polygon_id = "id")
sf$val <- list(p1,p2)

res <- interleave:::rcpp_interleave_triangle( sf$geometry, list( sf$val ) )

expect_equal(
  res$properties[[1]]
  , c(p1, p2)[ res$input_index + 1 ]
)

## length-1 vectors used as properties, and specified as a list-column
p1 <- letters[1]
p2 <- letters[5]

sf <- sfheaders::sf_polygon( df, polygon_id = "id")
sf$val <- list(p1,p2)

expect_error(
  interleave:::rcpp_interleave_triangle( sf$geometry, list( sf$val ) )
  , "interleave - list-column properties must have the same number of elements as each geometry they belong to"
)

## Errors if list-column vectors aren't the same length as the number of coordinates in the geometry


## different sized geometries work fine, as long as the property lenghts match the number of coordinates

df <- data.frame(
  id = c(1,1,1,1,1, 2,2,2,2,2,2)
  , x = c(0,0,1,1,0, 2,2,3,3,4,2)
  , y = c(0,1,1,0,0, 2,3,3,2,2,2)
)

p1 <- letters[1:5]
p2 <- letters[6:1]  ## the 2nd geometry has 6 coordinates

sf <- sfheaders::sf_polygon( df, polygon_id = "id")
sf$val <- list(p1,p2)

res <- interleave:::rcpp_interleave_triangle( sf$geometry, list( sf$val ) )

expect_equal(
  res$properties[[1]]
  , c(p1, p2)[ res$input_index + 1 ]
)



df <- data.frame(
  id = c(1,1,1,1,1, 2,2,2,2,2)
  , x = c(0,0,1,1,0, 2,2,3,3,2)
  , y = c(0,1,1,0,0, 2,3,3,2,2)
)

sf <- sfheaders::sf_polygon( df, polygon_id = "id")
properties <- list(
  x = 1:4
  , y = 1:3
)

expect_error(
  interleave:::.test_interleave_triangle( sf$geometry, properties )
  , "interleave - list-column properties must have the same number of elements as each geometry they belong to"
  )


l <- list(
  matrix(1:16, ncol = 2)
  , matrix(1:16, ncol = 4)
)

expect_error(
  interleave:::.test_interleave_triangle( list( l ), list() )
  , "interleave - there is an issue with earcutting this polygon, perhaps it isn't closed?"
  )

## tringale with XYZ coords
df <- data.frame(
  x = c(0,0,1,1,0, 2,2,3,3,2)
  , y = c(0,1,1,0,0, 2,3,3,2,2)
  , z = 1:10
)


p1 <- letters[1:10]

m1 <- as.matrix( df )
m2 <- as.matrix( df[, c("x","y") ])

res1 <- interleave:::rcpp_interleave_triangle( list( list( m1 ) ) , list( p1 ) )
res2 <- interleave:::rcpp_interleave_triangle( list( list( m2 ) ) , list( p1 ) )

expect_true( ( length( res1$coordinates ) / res1$stride) == ( length( res2$coordinates ) / res2$stride )  )

## start indices shouldn't change
expect_equal( res1$start_indices, res2$start_indices )

## input indexes shouldn't change
expect_equal( res1$input_index, res2$input_index )

## properties shouldn't change
expect_equal( res1$properties, res2$properties )

## n-coordinates shouldn't change
expect_equal( res1$geometry_coordinates, res2$geometry_coordinates )

expect_true( res1$stride != res2$stride )
expect_true( res1$stride == res2$stride + 1)


## Testing interleave triangle and primitive return the same structure object

df <- data.frame(
  id = c(1,1,1,1,1, 2,2,2,2,2)
  , x = c(0,0,1,1,0, 2,2,3,3,2)
  , y = c(0,1,1,0,0, 2,3,3,2,2)
)

p1 <- letters[1:5]
p2 <- letters[5:1]

sf <- sfheaders::sf_polygon( df, polygon_id = "id")

res_tri <- interleave:::rcpp_interleave_triangle( sf$geometry, list() )
res_line <- interleave:::rcpp_interleave_line( sf$geometry )

expect_true( "coordinates" %in% names( res_line ) )
expect_true( "coordinates" %in% names( res_tri ) )
expect_true( "start_indices" %in% names( res_line ) )
expect_true( "start_indices" %in% names( res_tri ) )
expect_true( "geometry_coordinates" %in% names( res_line ) )
expect_true( "geometry_coordinates" %in% names( res_tri ) )
expect_true( "stride" %in% names( res_line ) )
expect_true( "stride" %in% names( res_tri ) )

expect_true( "total_coordinates" %in% names( res_line ) )
expect_true( !"total_coordinates" %in% names( res_tri ) )

expect_true( "input_index" %in% names( res_tri ) )
expect_true( "properties" %in% names( res_tri ) )

expect_true( !"input_index" %in% names( res_line ) )
expect_true( !"properties" %in% names( res_line ) )

## List Rows
err <- "interleave - expecting a list input"
expect_error( interleave:::.test_list_rows( 1:5 ), err)
expect_error( interleave:::.test_list_rows( matrix(1:4, ncol = 2) ), err )
expect_error( interleave:::.test_list_rows( data.frame(x = 1:3, y = 1:3 ) ), err )
expect_equal( interleave:::.test_list_rows( list( data.frame(x = 1:3, y = 1:3 ) ) ), list( 3 ) )

l <- list(
  1:10
  , matrix(1:16, ncol = 2)
  , list(
    list( data.frame(x = 1:10, y = 10:1 ) )
  )
)

expect_equal( interleave:::.test_list_rows( l ) , list(1,8,list(list(10))) )
expect_equal( unlist( interleave:::.test_list_rows( l ) ), c(1,8,10) )

## List Size
l <- list(
  1:10
  , matrix(1:16, ncol = 2)
  , list(
      1:4
      , matrix(1:10, ncol = 5)
    )
  , list(
    list( data.frame(x = 1:10, y = 10:1 ) )
  )
)

expect_equal( interleave:::.test_list_element_count( l ), list(10, 16, list(4, 10), list( list( 20 ) ) ) )

## Unlist list
expect_error( interleave:::.test_unlist_list( 1:4 ), err )
expect_error( interleave:::.test_unlist_list( matrix(1:4, ncol = 2) ), err)
expect_error( interleave:::.test_unlist_list( data.frame( x = 1:4 ) ), err )

expect_equal( interleave:::.test_unlist_list( list(1:4) ), c(1:4) )

l <- list(
  1:10
  , list(
    list(
      matrix(1:20, ncol = 2)
    )
  )
)

expect_equal( interleave:::.test_unlist_list( l ), c(1:10, 1:20)  )

l <- list(
  c(TRUE, TRUE, FALSE)
  , matrix(1:16, ncol = 2)
  , list(
    letters[1:4]
    , matrix(rep(T, 10), ncol = 5)
  )
  , list(
      list( data.frame(x = 1:10, y = 10:1 ) )
  )
)

list_sizes <- interleave:::.test_list_element_count( l)
expect_equal( interleave:::.test_unlist_list( list_sizes ),  unlist( list_sizes) )
expect_error( interleave:::.test_unlist_list( l ), err ) ## errors because there are df's and matrices in list

## empty list
lst <- list(list())
expect_equal(interleave::interleave(lst), logical())
expect_equal(interleave::interleave(list()), interleave::interleave(list(list())))

## single polygon
m <- matrix(c(0,0,0,1,1,1,1,0,0,0), ncol = 2, byrow = T)
l <- list( m )
ec <- interleave:::rcpp_earcut( l )
## Testing this is the same as supplying two triangles as LINEs
## expected:
t1 <- matrix(c(0,1,0,0,1,0), ncol = 2, byrow = T)
t2 <- matrix(c(1,0,1,1,0,1), ncol = 2, byrow = T)
tr <- interleave:::rcpp_interleave_line( list(t1, t2) )
expect_equal( ec$coordinates, tr$coordinates )
expect_equal( tr$start_indices, c(0,3))

### how does earcut work with M(Z) dimensions?
m <- matrix(c(0,0,1,0,1,1,1,1,3,1,0,4,0,0,1), ncol = 3, byrow = T)
l <- list( m )
ec <- interleave:::rcpp_earcut( l )
## the 'Z' coordinate is kept as-is on each coordinate

## what does earcutting triangles do?
m <- matrix(c(0,0,1,0,1,1,1,1,3,1,0,4,0,0,1), ncol = 3, byrow = T)
l <- list( m )
ec <- interleave:::rcpp_earcut( l )
tris <- matrix( ec$coordinates, ncol = 3, byrow = T)

interleave:::rcpp_earcut( list( tris ) )
ec
